function [UE_ULXRateperW,UE_DLXRateperW,UE_BS_distance] = SINR_interf_calc(UE_List,Location_BS,UE_Xmitpower,BS_Xmitpower,Noise,km,BW,Fc)


% BS_Xmitpower -> 1xB size
N = size( UE_List, 1);
B = size(Location_BS,1);
if ~isscalar(BS_Xmitpower)
   BS_Xmitpower = repmat(BS_Xmitpower,N,1);
end

global Freq_reuse  %Freq_reuse = [1 2 0 1 2 0 1 1 2 0 1 ]
Freq_reuse_map = repmat(Freq_reuse,N,1);
Freq_reuse_flag1 = Freq_reuse_map == 0;
Freq_reuse_flag2 = Freq_reuse_map == 1;
Freq_reuse_flag3 = Freq_reuse_map == 2;


%UE_SINR = zeros(N,B);
%UE_DLSINR= zeros(N,B);
%UE_BS_distance = zeros(N,B);
%UE_ULXRateperW = zeros(N,B);
%UE_DLXRateperW= zeros(N,B);
%calculate distance
UE_BS_distance = sqrt( ( UE_List(:,3)-Location_BS(:,1)' ).^2 + ( UE_List(:,4)-Location_BS(:,2)' ).^2  );

FFAD = normrnd(0,8,[N,B]);

log_UED = 22.7 + 26*log10(Fc) + 36.7 * log10( UE_BS_distance );

Received_UEdbm = BS_Xmitpower - log_UED - FFAD;

Received_UEmW = 10.^(0.1*(Received_UEdbm));

Interfer_UEmW1 = sum( Received_UEmW.*Freq_reuse_flag1 , 2) - Received_UEmW.*Freq_reuse_flag1;
Interfer_UEmW2 = sum( Received_UEmW.*Freq_reuse_flag2 , 2) - Received_UEmW.*Freq_reuse_flag2;
Interfer_UEmW3 = sum( Received_UEmW.*Freq_reuse_flag3 , 2) - Received_UEmW.*Freq_reuse_flag3;
Interfer_UEmW = Interfer_UEmW1.*Freq_reuse_flag1+Interfer_UEmW2.*Freq_reuse_flag2+Interfer_UEmW3.*Freq_reuse_flag3;
UE_SINR   = 10.^(0.1*(UE_Xmitpower-log_UED - Noise - FFAD));
%UE_DLSINR = 10.^(0.1*(Received_UEdbm - (Noise + Interfer_UEdbm) ));
UE_DLSINR = 10.^(0.1*(Received_UEdbm)) ./ (10.^(0.1*(Noise)) + Interfer_UEmW) ;
% for j = 1:N
%    for k = 1:B
%       FFAD = normrnd(0,8);
%       UE_SINR(j,k) = 10^( 0.1*((UE_Xmitpower)-( 22.7 + 26*log10(Fc) + 36.7 * log10( UE_BS_distance(j,k))) - Noise - FFAD));  
%       UE_DLSINR(j,k) = 10^(0.1*((BS_Xmitpower)-( 22.7 + 26*log10(Fc) + 36.7 * log10( UE_BS_distance(j,k))) - Noise - FFAD)); 
%    end
% end

UE_ULXRateperW = BW*log2(1+UE_SINR);
UE_DLXRateperW = BW*log2(1+UE_DLSINR);
% for j = 1:N
%    for k = 1:B
%       UE_ULXRateperW(j,k) = BW*log2(1+UE_SINR(j,k));
%       UE_DLXRateperW(j,k) = BW*log2(1+UE_DLSINR(j,k));
%    end
% end
end