T_last = 3600*4;
x_limit = 3014.87;
%6BSequally seperated
N_BS = floor((x_limit-150)/200)+1;

%% DEBUG
global debug_variable_1
global debug_variable_2
global debug_variable_3

%% assign solar power
load('Solar.mat');
Panelsize =  0.8+0.8*0.3;  %bifacial: 1.6+1.6*0.3
Enecov_eff = 0.18;


%---------------------------------------------------------------
solar_EBU_1day = EBU1(72929:72929+T_last-1); %72979 is 8AM, 44179 is 12AM
solar_Mesa_1day = EBU1(72929:72929+T_last-1); %72979 is 8AM, 44179 is 12AM
solar_Mesa2_1day = EBU1(72929:72929+T_last-1); %72979 is 8AM, 44179 is 12AM
%solar to each basestation
solar_BS_1s_1day = zeros(N_BS,T_last);
for i = 1:N_BS
    solarR = rand();
    if solarR < 1/3
     solar_BS_1s_1day(i,:) = (0.4*rand(1,T_last)+0.8) .* solar_EBU_1day' *Enecov_eff*Panelsize; %0.15*0.6
    elseif solarR>=1/3 && solarR < 2/3
     solar_BS_1s_1day(i,:) = (0.4*rand(1,T_last)+0.8) .* solar_Mesa_1day' *Enecov_eff*Panelsize; %0.15*0.6 
    else
     solar_BS_1s_1day(i,:) = (0.4*rand(1,T_last)+0.8) .* solar_Mesa2_1day' *Enecov_eff*Panelsize; %0.15*0.6
    end
end
%% power parameters:
global Comp_fullW;
Comp_fullW = 1.45*10;
global Ca;
Ca = (10*4414)^2;
global ca;
ca = 4414*10;
global DL_fullW;
DL_fullW = 12;
global UL_fullW;
UL_fullW = 2;
global fullRB;
fullRB = 360;
global DL_avalRB;
DL_avalRB = 720;
global afa;
afa = Comp_fullW /Ca;
global bet;
bet = DL_fullW/fullRB;
global gam;
gam = UL_fullW/fullRB;


%% UE_control
DL_data_sect1 = 1/2;%1/3
DL_data_sect2 = 3/4;%2/3

%% Handover control
Delay_HO = 0.04;
%% create map
N_Lane = 22;
N_Lseg = 6;
N_Cros = 5;
type_laddar = 0.25;
UE_Xmitpower = 23;                                                         %dbm
BS_Xmitpower = 30;
km = 1000;
BW = 12*(15e3); 
Noise = -174+10*log10(BW) ;
Fc = 1.7;     %Ghz

Location_BS = zeros(N_BS,2);
for bs = 1:N_BS
    Location_BS(bs,:) = [100+200*(bs-1) 0];
%     scatter(Location_BS(bs,1),Location_BS(bs,2),'ro');
%     hold on
end
% Location_BS(2,:) = [570*1/4 600*3/6];
% Location_BS(3,:) = [570*1/4 600*1/6];
% Location_BS(4,:) = [570*3/4 600*5/6];
% Location_BS(5,:) = [570*3/4 600*3/6];
% Location_BS(6,:) = [570*3/4 600*1/6];

%9BS
% Location_BS = zeros(N_BS,2);  
% Location_BS(1,:) = [164.23 495.70];
% Location_BS(2,:) = [117.82 291.30];
% Location_BS(3,:) = [97.58 123.88];
% Location_BS(4,:) = [345.91 499.40];
% Location_BS(5,:) = [295.10 345.58];
% Location_BS(6,:) = [265.81 161.88];
% Location_BS(7,:) = [499.33 509.67];
% Location_BS(8,:) = [465.86 345.92];
% Location_BS(9,:) = [424.60 125.48];

%5BS
% Location_BS = zeros(N_BS,2);  
% temp_Location_BS = zeros(9,2);  
% temp_Location_BS(1,:) = [164.23 495.70];
% temp_Location_BS(2,:) = [117.82 291.30];
% temp_Location_BS(3,:) = [97.58 123.88];
% temp_Location_BS(4,:) = [345.91 499.40];
% temp_Location_BS(5,:) = [295.10 345.58];
% temp_Location_BS(6,:) = [265.81 161.88];
% temp_Location_BS(7,:) = [499.33 509.67];
% temp_Location_BS(8,:) = [465.86 345.92];
% temp_Location_BS(9,:) = [424.60 125.48];
% Location_BS(1,:) = 1/2*temp_Location_BS(1,:)+1/4*temp_Location_BS(2,:)+1/4*temp_Location_BS(4,:);
% Location_BS(2,:) = 1/2*temp_Location_BS(3,:)+1/4*temp_Location_BS(2,:)+1/4*temp_Location_BS(6,:);
% Location_BS(3,:) = 1/2*temp_Location_BS(9,:)+1/4*temp_Location_BS(6,:)+1/4*temp_Location_BS(8,:);
% Location_BS(4,:) = 1/2*temp_Location_BS(7,:)+1/4*temp_Location_BS(4,:)+1/4*temp_Location_BS(8,:);
% Location_BS(5,:) = [295.10 345.58];


% plot(Location_BS(:,1),Location_BS(:,2),'r*');
% hold on
Crosspt = [487.57, 869.38, 1517.76,2125.38,2820.72,3014.87,4212.39];

Lane_A_B = zeros(N_Lane,4);
Lane_A_B(1,:) = [0         0     487.57      0];  %L1S
Lane_A_B(2,:) = [487.57    0     869.38      0];  %L2S
Lane_A_B(3,:) = [869.38    0     1517.76     0];  %L3S
Lane_A_B(4,:) = [1517.76   0     2125.38     0];  %L4S
Lane_A_B(5,:) = [2125.38   0     2820.72     0];  %L5S
Lane_A_B(6,:) = [2820.72   0     3014.87     0];  %L6S
% Lane_A_B(7,:) = [3014.87   0     4212.39     0];  %L7S
% Lane_A_B(8,:) = [4212.39   0     4662.43     0];  %L8S
Lane_A_B(7,:) = [487.57    0     0           0];  %L1N
Lane_A_B(8,:) = [869.38    0     487.57      0];  %L2N
Lane_A_B(9,:) = [1517.76   0     869.38      0];  %L3N
Lane_A_B(10,:) = [2125.38   0     1517.76     0];  %L4N
Lane_A_B(11,:) = [2820.72   0     2125.38     0];  %L5N
Lane_A_B(12,:) = [3014.87   0     2820.72     0];  %L6N
% Lane_A_B(15,:) = [4212.39   0     3014.87     0];  %L7N
% Lane_A_B(16,:) = [4662.43   0     4212.39     0];  %L8N
Lane_A_B(13,:) = [347.86    100   627.28   -100];  %C1S
Lane_A_B(14,:) = [703.08    100   869.38      0];  %C2S
Lane_A_B(15,:) = [1376.87   100   1658.65  -100];  %C3S
Lane_A_B(16,:) = [2071.05  -100   2179.71   100];  %C4N
Lane_A_B(17,:) = [2801.72  -100   2839.72   100];  %C5N
% Lane_A_B(22,:) = [3009.73  -100   3020.01   100];  %C6N
% Lane_A_B(23,:) = [4034.06   100   4212.39     0];  %C7S
Lane_A_B(18,:) = [627.28   -100   347.86    100];  %C1N
Lane_A_B(19,:) = [869.38      0   703.08    100];  %C2N
Lane_A_B(20,:) = [1658.65  -100   1376.87   100];  %C3N
Lane_A_B(21,:) = [2179.71   100   2071.05  -100];  %C4S
Lane_A_B(22,:) = [2839.72   100   2801.72  -100];  %C5S
% Lane_A_B(29,:) = [3020.01   100   3009.73  -100];  %C6S
% Lane_A_B(30,:) = [4212.39     0   4034.06   100];  %C7N

M_a = zeros(N_Lane,1);
M_b = zeros(N_Lane,1);
for i = 1:N_Lane
   M_a(i,1) =  ( Lane_A_B(i,4) - Lane_A_B(i,2) ) / ( Lane_A_B(i,3) - Lane_A_B(i,1) );
   M_b(i,1) =  Lane_A_B(i,4) - Lane_A_B(i,3)*M_a(i,1);
end

Volumn = zeros(N_Lane,24);

Volumn(1,:)=[ 568 602 681 694 706 743 715 693 666 551 510 439 336 223 182 155 133 189 350 490 567 578 558 589]; %12PM-12PM %L1S
Volumn(2,:)=[ 524 525 497 513 510 526 535 483 416 367 361 258 150 92 84 95 187 445 848 906 786 647 569 522]; %L2S
Volumn(3,:)=[ 757 768 810 825 905 977 912 847 724 568 453 381 283 179 110 118 190 198 312 586 722 767 719 672];%L3S
Volumn(4,:)=[ 678 688 740 739 806 878 828 746 646 510 408 347 251 160 101 106 166 173 285 526 647 684 647 609 ];%L4S
Volumn(5,:)=[ 569 562 602 661 638 598 629 577 501 437 363 275 177 100 76 65 132 327 694 880 839 686 621 573];%L5S
Volumn(6,:)=[ 848 929 1023 935 1012 1059 982 924 814 602 475 385 228 146 98 98 138 275 465 687 834 811 746 775];%L6S
% Volumn(7,:)=[ 652 731 756 731 841 755 904 915 804 656 543 413 298 199 124 81 72 73 152 285 453 609 640 654];%L7S
% Volumn(8,:)=[ 1228 1306 1433 1551 1419 1554 1445 1233 1010 805 654 458 205 145 115 98 153 347 635 937 1129 1106 1160 1171 ];%L8S
Volumn(7,:)=[ 635 645 643 683 594 621 610 588 510 542 452 389 221 174 139 125 182 489 719 852 791 669 625 645];%L1N
Volumn(8,:)=[ 548 565 641 643 667 709 711 652 559 451 391 340 249 149 113 87 121 156 349 512 536 530 507 532 ];%L2N
Volumn(9,:)=[ 741 733 831 790 829 834 854 770 686 681 583 454 288 191 154 141 249 660 1068 1141 1089 887 769 736];%L3N
Volumn(10,:)=[ 661 664 746 704 745 742 772 685 612 618 523 407 259 173 139 126 232 598 969 1027 964 796 697 666];%L4N
Volumn(11,:)=[ 648 668 758 802 775 860 805 738 618 486 396 300 210 116 79 70 99 221 378 610 669 625 556 618];%L5N
Volumn(12,:)=[ 903 789 903 920 969 987 881 844 818 724 560 424 263 171 121 100 175 516 1000 1194 1121 918 838 860];%L6N
% Volumn(15,:)=[ 675 705 703 680 763 788 792 771 722 613 514 433 309 202 122 74  58  70  153  428 765 843 782 736];%L7N
% Volumn(16,:)=[ 819 862 899 958 929 904 830 804 711 624 458 389 233 134 71 62 104 272 602 882 912 898 799 753 ];%L8N
Volumn(13,:)=[ 356 365 410 473 445 448 410 357 282 219 207 161 123 57 35 24 29 55 113 163 299 318 334 320 ];%C1S
Volumn(14,:)=[ 518 510 554 567 561 630 610 554 479 426 345 231 156 107 66 63 82 163 381 722 751 539 509 504]./2;%C2S
Volumn(15,:)=[ 478 471 508 607 648 657 625 653 692 611 518 421 343 242 172 141 116 135 236 427 557 607 528 487 ];%C3S
Volumn(16,:)=[ 186 191 251 282 296 312 266 194 143 119 122 82 63 39 24 16 22 50 104 205 260 197 178 174];%C4N
Volumn(17,:)=[ 560 615 707 766 801 855 614 457 355 223 213 156 90 37 45 49 69 168 492 899 979 783 629 567];%C5N
% Volumn(22,:)=[ 276 283 343 403 393 420 339 283 216 155 132 88 59 29 25 15 14 45 112 283 356 270 250 251];%C6N
% Volumn(23,:)=[ 597 621 613 619 610 613 569 524 395 288 246 170 120 84 51 53 75 104 181 290 363 435 507 581 ];%C7S
Volumn(18,:)=[ 306 388 418 437 497 481 371 387 307 161 100 66 31 23 14 16 29 68 269 436 444 273 329 318 ];%C1N
Volumn(19,:)=[ 518 510 554 567 561 630 610 554 479 426 345 231 156 107 66 63 82 163 381 722 751 539 509 504]./2;%C2N
Volumn(20,:)=[ 353 392 435 431 412 403 352 306 240 178 130 79 50 38 30 26 57 134 331 572 491 359 343 338];%C3N
Volumn(21,:)=[ 250 253 281 321 297 305 286 250 222 203 176 123 88 52 32 33 24 41 115 204 253 227 238 228 ];%C4S
Volumn(22,:)=[ 491 499 627 640 684 671 548 415 276 191 167 128 85 46 32 31 54 101 280 663 604 604 470 482 ];%C5S
% Volumn(29,:)=[235 250 307 281 265 254 244 194 135 90 89 55 42 24 14 12 18 49 133 336 298 234 216 223 ];%C6S
% Volumn(30,:)=[ 534 566 560 583 601 575 566 513 445 368 322 207 154 89 62 52 71 102 217 384 433 443 444 516];%C7N


Volumn_1s = zeros(N_Lane,86400);
for nl = 1:N_Lane
  for i = 1:24
    for j = 1:3600
        Volumn_1s( nl ,(i-1)*3600+j) = Volumn(nl,i)/(3600) ; %120 84 51 53 75 104 181 290 363 435 507 581 597 621 613 619 610 613 569 524 395 288 246 170
    end
  end
end

EnergyCom_BS_min = zeros(N_BS,T_last);
EnergyCom_BS_womin = zeros(N_BS,T_last);
EnergyCom_UE2BS_min = zeros(N_BS,T_last);

EnergyCom_BS_ori = zeros(N_BS,T_last);
EnergyCom_UE2BS_ori = zeros(N_BS,T_last);

Asso_needed = zeros(N_BS,T_last);
ULRB_needed_min = zeros(N_BS,T_last);
DLRB_needed_min = zeros(N_BS,T_last);
Com_needed_min = zeros(N_BS,T_last);
ULRB_needed_womin = zeros(N_BS,T_last);
DLRB_needed_womin = zeros(N_BS,T_last);
Com_needed_womin = zeros(N_BS,T_last);


UE_List = [1, 10, Lane_A_B(1,1)+0.1, Lane_A_B(1,2) ,10,10,0.1, 0.1, 0]; %1: Lane, 2: Velocity(m/s), 3:X, 4:Y, 5: 10MB/s for uploading, 6:10MIPS, 7:0.1MB/s downloading 8:delay requirement: 0.1s 9:video downloading size(<1/3: only alarm message, 1/3<&&<2/3: 720p video, >2/3: 1080p video)

UE_List_record = zeros(1,9,T_last);
N_UE_record = zeros(1,T_last);

Asso_UE_record = zeros(1,1,T_last);
Asso_UE_record_womin= zeros(1,1,T_last);
UE_XULrate_Record = zeros(1,N_BS,T_last);  
UE_XDLrate_Record = zeros(1,N_BS,T_last);  
UE_ListAssoAB_Record = zeros(1,3,T_last); 
UE_ListAssoAB_Record_womin = zeros(1,3,T_last); 
N_car = zeros(N_Lane,1);
UE_distri_cropt = zeros(N_Cros,6,T_last);
UE_distri_crost = zeros(N_Cros,6,T_last);

for ts = 1:T_last
    
    if mod(ts,100) == 0
       disp(['generate UE list: ts =' num2str(ts)]); 
    end
    %% calculate power consumption request for eac BS
    N_UE = size( UE_List, 1);
    cancel_list = [];
    for lan_o = 1:N_Cros
        lan = 2*N_Lseg+lan_o;
        lan_x = zeros(1,3);
        lan_y = zeros(1,3);
        lan_b = zeros(1,3);
        lan_c = zeros(1,3);
        % a = Volumn_1s(lan_o+N_Lseg,ts);
        % b = Volumn_1s(lan_o+N_Lseg+1,ts);
        % c = Volumn_1s(lan_o,ts);
        % d = Volumn_1s(lan_o+1,ts);
        % e = Volumn_1s(lan,ts);
        % f = Volumn_1s(lan+N_Cros,ts);
        lan_x(1,2) = max( Volumn_1s(lan_o+1,ts)-Volumn_1s(lan_o,ts) , 0 ) *Volumn_1s(lan+N_Cros,ts)  /(Volumn_1s(lan,ts)+Volumn_1s(lan+N_Cros,ts));
        lan_x(1,3) = max( Volumn_1s(lan_o+1,ts)-Volumn_1s(lan_o,ts) , 0 ) *Volumn_1s(lan,ts)          /(Volumn_1s(lan,ts)+Volumn_1s(lan+N_Cros,ts));
        lan_y(1,2) = max( Volumn_1s(lan_o+N_Lseg,ts)-Volumn_1s(lan_o+N_Lseg+1,ts)  , 0 ) *Volumn_1s(lan+N_Cros,ts)   /(Volumn_1s(lan,ts)+Volumn_1s(lan+N_Cros,ts));
        lan_y(1,3) = max( Volumn_1s(lan_o+N_Lseg,ts)-Volumn_1s(lan_o+N_Lseg+1,ts)  , 0 ) *Volumn_1s(lan,ts)          /(Volumn_1s(lan,ts)+Volumn_1s(lan+N_Cros,ts));
        
        lan_b(1,2) = max( Volumn_1s(lan_o+N_Lseg+1,ts)-Volumn_1s(lan_o+N_Lseg,ts) , 0 )*Volumn_1s(lan+N_Cros,ts)  /(Volumn_1s(lan,ts)+Volumn_1s(lan+N_Cros,ts));
        lan_b(1,3) = max( Volumn_1s(lan_o+N_Lseg+1,ts)-Volumn_1s(lan_o+N_Lseg,ts) , 0 )*Volumn_1s(lan,ts)         /(Volumn_1s(lan,ts)+Volumn_1s(lan+N_Cros,ts));
        
        lan_c(1,2) = max( Volumn_1s(lan_o,ts)-Volumn_1s(lan_o+1,ts), 0 ) *Volumn_1s(lan+N_Cros,ts)  /(Volumn_1s(lan,ts)+Volumn_1s(lan+N_Cros,ts));
        lan_c(1,3) = max( Volumn_1s(lan_o,ts)-Volumn_1s(lan_o+1,ts), 0 ) *Volumn_1s(lan,ts)         /(Volumn_1s(lan,ts)+Volumn_1s(lan+N_Cros,ts));
        lan_x(1,1) = 1/4*max(  Volumn_1s(lan,ts)+Volumn_1s(lan+N_Cros,ts) -abs(Volumn_1s(lan_o+1,ts)-Volumn_1s(lan_o,ts))-abs(Volumn_1s(lan_o+N_Lseg+1,ts)-Volumn_1s(lan_o+N_Lseg,ts)) , 0);
        lan_y(1,1) = lan_x(1,1);
        
        lan_b(1,1) = min(  Volumn_1s(lan_o+N_Lseg,ts), Volumn_1s(lan_o+N_Lseg+1,ts));
        lan_c(1,1) = min(  Volumn_1s(lan_o,ts),Volumn_1s(lan_o+1,ts) );
        
        UE_distri_cropt(lan_o,:,ts) = reshape( [lan_c,lan_b], size(UE_distri_cropt(lan_o,:,ts)));
        UE_distri_crost(lan_o,:,ts) = reshape( [lan_x,lan_y], size(UE_distri_crost(lan_o,:,ts)));        
    end
    %update each users position and parameter
    for u = 1:N_UE
      if mod(ts,10) == 0
         plot(UE_List(u,3),UE_List(u,4),'b*');
         hold on
      end
        lan_idx = floor(UE_List(u,1));
        dx = (-1^(Lane_A_B(lan_idx,3) < Lane_A_B(lan_idx,1)))*sqrt(UE_List(u,2)^2/(1+M_a(lan_idx,1)^2));               %Note that dx can only be positive.
        dy = M_a(lan_idx,1)*dx;                                       %dy can be negative, based on M_a
        
        UE_List(u,4) = UE_List(u,4) + dy;
        UE_List(u,3) = UE_List(u,3) + dx;
        
        if lan_idx <= 2*N_Lseg
           if dx > 0 %south buond
              Cross = (UE_List(u,3)>Crosspt).*((UE_List(u,3)-dx)<Crosspt) ;
              seg_idx = find(Cross);
              seg_csum = sum( UE_distri_cropt(seg_idx,1:3,ts) ,2);
              if ~isequal(size(seg_csum),size(1))
                warning('seg_csum not well computed');
                pause;
              end
              seg_cprob = UE_distri_cropt(seg_idx,1:3,ts)./seg_csum;
              seg_flag = rand();
             if ~isempty(seg_csum)
              if  seg_flag< seg_cprob(1,1,1)
                  %do nothing
              elseif seg_flag>= seg_cprob(1,1,1) && seg_flag< 1-seg_cprob(1,3,1) 
                  UE_List(u,1) = 2*N_Lseg + seg_idx + N_Cros;
                  dx1 = Crosspt(1,seg_idx) - (UE_List(u,3) - dx);
                  dy1 = M_a(lan_idx,1)*dx1;
                  dx2 = -1^(Lane_A_B(UE_List(u,1),3) < Lane_A_B(UE_List(u,1),1))*sqrt((UE_List(u,2)-sqrt(dx1^2+dy1^2))^2/(1+M_a(UE_List(u,1),1)^2));    
                  dy2 = M_a(UE_List(u,1),1)*dx2;
                  UE_List(u,3) = UE_List(u,3) - dx + dx1 + dx2; 
                  UE_List(u,4) = UE_List(u,4) - dy + dy2 + dy1;
              else
                  UE_List(u,1) = 2*N_Lseg + seg_idx;
                  dx1 = Crosspt(1,seg_idx) - (UE_List(u,3) - dx);
                  dy1 = M_a(lan_idx,1)*dx1;
                  dx2 = -1^(Lane_A_B(UE_List(u,1),3) < Lane_A_B(UE_List(u,1),1))*sqrt((UE_List(u,2)-sqrt(dx1^2+dy1^2))^2/(1+M_a(UE_List(u,1),1)^2));    
                  dy2 = M_a(UE_List(u,1),1)*dx2;
                  UE_List(u,3) = UE_List(u,3) - dx + dx1 + dx2; 
                  UE_List(u,4) = UE_List(u,4) - dy + dy2 + dy1;                  
              end
             end
           else %dx < 0 north bound
              Cross = (UE_List(u,3)<Crosspt).*((UE_List(u,3)-dx)>Crosspt) ;
              seg_idx = find(Cross);
              seg_csum = sum( UE_distri_cropt(seg_idx,4:6,ts) ,2);
              if ~isequal(size(seg_csum),size(1)) &&  ~isempty(seg_csum)
                warning('seg_csum not well computed');
                pause;
              end
              seg_cprob = UE_distri_cropt(seg_idx,4:6,ts)./seg_csum;
              seg_flag = rand();
             if ~isempty(seg_csum)
              if  seg_flag < seg_cprob(1,1,1)
                  %do nothing
              elseif seg_flag>= seg_cprob(1,1,1) && seg_flag< 1-seg_cprob(1,3,1) 
                  UE_List(u,1) = 2*N_Lseg + seg_idx + N_Cros;
                  dx1 = Crosspt(1,seg_idx) - (UE_List(u,3) - dx);
                  dy1 = M_a(lan_idx,1)*dx1;
                  dx2 = -1^(Lane_A_B(UE_List(u,1),3) < Lane_A_B(UE_List(u,1),1))*sqrt((UE_List(u,2)-sqrt(dx1^2+dy1^2))^2/(1+M_a(UE_List(u,1),1)^2));    
                  dy2 = M_a(UE_List(u,1),1)*dx2;
                  UE_List(u,3) = UE_List(u,3) - dx + dx1 + dx2; 
                  UE_List(u,4) = UE_List(u,4) - dy + dy2 + dy1;
              else
                  UE_List(u,1) = 2*N_Lseg + seg_idx;
                  dx1 = Crosspt(1,seg_idx) - (UE_List(u,3) - dx);
                  dy1 = M_a(lan_idx,1)*dx1;
                  dx2 = -1^(Lane_A_B(UE_List(u,1),3) < Lane_A_B(UE_List(u,1),1))*sqrt((UE_List(u,2)-sqrt(dx1^2+dy1^2))^2/(1+M_a(UE_List(u,1),1)^2));    
                  dy2 = M_a(UE_List(u,1),1)*dx2;
                  UE_List(u,3) = UE_List(u,3) - dx + dx1 + dx2; 
                  UE_List(u,4) = UE_List(u,4) - dy + dy2 + dy1;                  
              end 
             end
           end
        else %UE at crossed street
            if ( UE_List(u,4)>0 && UE_List(u,4)-dy < 0 ) || ( UE_List(u,4)<0 && UE_List(u,4)-dy > 0 )
            %lane: lan_idx    type: UE_List(u,1) - lan_idx 
                   if ( UE_List(u,1) - lan_idx )/type_laddar ~= 0 && ( UE_List(u,1) - lan_idx )/type_laddar ~= 1 && ( UE_List(u,1) - lan_idx )/type_laddar ~= 2
                      warning('switch on error calculation');
                      pause;
                   end
              switch ( UE_List(u,1) - lan_idx )/type_laddar

                   case 0
                       %do nothing
                   case 1
                       UE_List(u,1) = lan_idx - 2*N_Lseg - N_Cros*( lan_idx > 2*N_Lseg + N_Cros) +1;
                       UE_List(u,3) = Lane_A_B(UE_List(u,1),1)+ 0.1;
                       UE_List(u,4) = Lane_A_B(UE_List(u,1),2);
                   case 2
                       UE_List(u,1) = lan_idx - N_Lseg - N_Cros*( lan_idx > 2*N_Lseg + N_Cros) ;
                       UE_List(u,3) = Lane_A_B(UE_List(u,1),1) - 0.1;
                       UE_List(u,4) = Lane_A_B(UE_List(u,1),2);
               end
            end
        end
        
        UE_List(u,6) = 9 + 2*rand();%upload video
        % UE_List(u,9) =  remain the same;0*(UE_List(u,9)<=DL_data_sect1) + ( (7.34-0.734) + 0.734*2*rand() )*((UE_List(u,9)>DL_data_sect1)&&(F_Ddata<=DL_data_sect2)) + ( (12.33-1.233) + 1.233*2*rand() )*(UE_List(u,9)>DL_data_sect2);%download size  0.1 + 0.2*rand() if not consider video downloading   720p: 7.34MB/s, 1080p:12.33
        UE_List(u,7) =  0.1 + 0.2*rand();
        UE_List(u,8) =  0.1 + 0.2*rand();
        if UE_List(u,4)>100 || UE_List(u,3)>4662.43 || UE_List(u,4)<-100 || UE_List(u,3)<0
           cancel_list = [cancel_list u];
        end
    end
    UE_List(cancel_list,:) = [];

    for lan_o = 1:N_Cros
        lan = 2*N_Lseg+lan_o;
        lan_xy = [UE_distri_crost(lan_o,1:3,ts) ; UE_distri_crost(lan_o,4:6,ts)];
       for lan_temp = 1:2 
        for distri = 1:3
           Posn = poissrnd( lan_xy(lan_temp,distri) ,1 );
           N_car(lan+(lan_temp-1)*N_Cros,1) = N_car(lan+(lan_temp-1)*N_Cros,1)+Posn;
           for neu = 1:Posn
              F_Ddata = rand();
              temp_Ddata = 0*(F_Ddata<=DL_data_sect1) + ( 7.34*((F_Ddata>DL_data_sect1)&&(F_Ddata<=DL_data_sect2)) ) + ( 12.33*(F_Ddata>DL_data_sect2) );
              UE_List = [UE_List; lan+(lan_temp-1)* N_Cros + (distri-1)*type_laddar , 10+7*rand() , Lane_A_B(lan+(lan_temp-1)*N_Cros,1), Lane_A_B(lan+(lan_temp-1)*N_Cros,2),10,9 + 2*rand(),  0.1 + 0.2*rand()  ,0.1 + 0.2*rand(),temp_Ddata];
           end
        end
       end
    end
    for lan_temp = 1:2 
        Posn = poissrnd( Volumn_1s( 1 + (lan_temp-1)*(2*N_Lseg-1),ts) ,1 );
           for neu = 1:Posn
              %warning('create main street UE');
              F_Ddata = rand();
              temp_Ddata = 0*(F_Ddata<=DL_data_sect1) + ( 7.34*((F_Ddata>DL_data_sect1)&&(F_Ddata<=DL_data_sect2)) ) + ( 12.33*(F_Ddata>DL_data_sect2) );
              UE_List = [UE_List; 1+(lan_temp-1)*(2*N_Lseg-1) , 10+7*rand() , Lane_A_B(1+(lan_temp-1)*(2*N_Lseg-1),1), Lane_A_B(1+(lan_temp-1)*(2*N_Lseg-1),2),10,9 + 2*rand(),  0.1 + 0.2*rand()  ,0.1 + 0.2*rand(),temp_Ddata];
           end
    end
    
    %end of update UE list.
    N_UE = size( UE_List, 1);
    num_ListCol = size( UE_List, 2);
    N_UE_record(1,ts) =  N_UE;
    UE_List_record(1:N_UE,:,ts) = reshape( UE_List, [N_UE, num_ListCol , 1]);
    
    [UE_XULrate ,UE_XDLrate,UE_BS_distance]= SINR_calc(UE_List,Location_BS,UE_Xmitpower,BS_Xmitpower,Noise,km,BW,Fc);
    UE_XULrate = UE_XULrate./8./1024^2;
    UE_XDLrate = UE_XDLrate./8./1024^2;
    [Hst_rate, asso] = max(UE_XULrate,[],2);
    asso_womin = asso;
    UE_XDLrate_Record(1:N_UE,:,ts) = reshape( UE_XDLrate, [N_UE, N_BS , 1]);
    UE_XULrate_Record(1:N_UE,:,ts) = reshape( UE_XULrate, [N_UE, N_BS , 1]);
    
    %end of calculate Xmit rate
    N_UE_2 = size( UE_List, 1);

    
    for ue = 1:N_UE_2
        Asso_needed( asso(ue,1) , ts ) = Asso_needed( asso(ue,1) , ts )+1;
        if  ceil(UE_List(ue,5)/Hst_rate(ue,1))<=1e6
            ULRB_needed_min( asso(ue,1) , ts ) = ULRB_needed_min(asso(ue,1) , ts) + ceil(UE_List(ue,5)/Hst_rate(ue,1));
            %ULRB_needed_ori( asso(ue,1) , ts ) = ULRB_needed_ori(asso(ue,1) , ts) + ceil(UE_List(ue,5)/Hst_rate(ue,1));
        end
        
         %[com_ue, DLRB_ue] = minpower_COM_DLRB(UE_List(ue,6),UE_List(ue,7),UE_XDLrate(ue,asso(ue,1)),UE_List(ue,8),Comp_fullW,ca,DL_fullW,fullRB,DL_avalRB);
        
         
        %Com_needed_ori( asso(ue,1) , ts ) = Com_needed_ori(asso(ue,1) , ts) + ceil(UE_List(ue,6)/(0.5*UE_List(ue,8)));
        %DLRB_needed_ori( asso(ue,1) , ts ) = DLRB_needed_ori(asso(ue,1) , ts) + ceil(UE_List(ue,7)/Hst_rate(ue,1)/(0.5*UE_List(ue,8)));
    end
        [ULRB_needed_womin( : , ts ) , asso_womin] = ULRB_check_asso(ULRB_needed_min( : , ts ) , asso_womin , UE_List, UE_XULrate);
        [ULRB_needed_min( : , ts ) , asso] = ULRB_check_asso(ULRB_needed_min( : , ts ) , asso , UE_List, UE_XULrate);
        
        
        [UE_ListAssoAB_t, Resouce_needed,asso] = minpower_w_limComRB_func(UE_List, asso,UE_XDLrate);
        [UE_ListAssoAB_womin, Resouce_needed_womin,asso_womin] = minpower_wo_limComRB_func(UE_List, asso_womin,UE_XDLrate);
        %with min-energy 
        DLRB_needed_min(:,ts) = Resouce_needed(:,2);% already count DLStreaming
        Com_needed_min(:,ts) = Resouce_needed(:,1);
        UE_ListAssoAB_Record(1:N_UE,:,ts) = reshape( UE_ListAssoAB_t, [N_UE, size(UE_ListAssoAB_Record,2),1]);
        EnergyCom_BS_min(:,ts) = BSpowerf(ULRB_needed_min(:,ts), DLRB_needed_min(:,ts), Com_needed_min(:,ts));        
        Asso_UE_record(1:N_UE,:,ts) = reshape( asso, [N_UE, 1 , 1]);
        
        %without min-energy
        
        DLRB_needed_womin(:,ts) = Resouce_needed_womin(:,2);% already count DLStreaming
        Com_needed_womin(:,ts) = Resouce_needed_womin(:,1);
        UE_ListAssoAB_Record_womin(1:N_UE,:,ts) = reshape( UE_ListAssoAB_womin, [N_UE, size(UE_ListAssoAB_Record_womin,2),1]);
        EnergyCom_BS_womin(:,ts) = BSpowerf(ULRB_needed_womin(:,ts), DLRB_needed_womin(:,ts), Com_needed_womin(:,ts));        
        Asso_UE_record_womin(1:N_UE,:,ts) = reshape( asso_womin, [N_UE, 1 , 1]);        
        
        for bs = 1:N_BS
              chflag = asso == bs;
              chflag_womin = asso_womin == bs;
              [UE_ListAssoAB_ch, Resouce_needed_ch, Valid_ch] = minpower1BS_w_limComRB_func(UE_List(chflag,:),UE_XDLrate(chflag,:),bs);
              [UE_ListAssoAB_ch_womin, Resouce_needed_ch_womin, Valid_ch_womin] = minpower1BS_w_limComRB_func(UE_List(chflag_womin,:),UE_XDLrate(chflag_womin,:),bs);
              if Valid_ch == 0 
                 warning('result of minpower1BS and minpower are not the same under same condition');
                 pause;
              end
              if Valid_ch_womin == 0 
                 warning('result of minpower1BS and minpower are not the same under same condition');
                 pause;
              end
        end 

end
for bs = 1:N_BS

    scatter(Location_BS(bs,1),Location_BS(bs,2),'kd', 'filled');
    hold on
end