%script
global T_last;
T_last = 86400;
global battery_initial_level;
battery_initial_level = 0;
%% DEBUG
global debug_variable_1
global debug_variable_2
global debug_variable_3
%% power parameters:
global Comp_fullW;
Comp_fullW = 1.45;
global Ca;
Ca = (4414)^2;
global ca;
ca = 4414;
global DL_fullW;
DL_fullW = 12;
global UL_fullW;
UL_fullW = 2;
global fullRB;
fullRB = 360;
global DL_avalRB;
DL_avalRB = 720;
global afa;
afa = Comp_fullW /Ca;
global bet;
bet = DL_fullW/fullRB;
global gam;
gam = UL_fullW/fullRB;

%% assign solar power
load('Solar_parced_data.mat');
Panelsize =  ( 0.2+0.2*0.3 ) *Mul;  %bifacial: 1.6+1.6*0.3
Enecov_eff = 0.18;
x_limit = 3014.87;
global N_BS;
N_BS = floor((x_limit-150)/200)+1;

%---------------------------------------------------------------
%solar_EBU_1day = EBU1(72929+14400*2:72929+14400*2+T_last-1); %72979 is 8AM, 44179 is 12AM
%solar_Mesa_1day = Mesa(72929+14400*2:72929+14400*2+T_last-1); %72979 is 8AM, 44179 is 12AM
%solar_Mesa2_1day = EBU1(72929+14400:72929+14400+T_last-1); %72979 is 8AM, 44179 is 12AM
%solar to each basestation
% solar_BS_1s_1day = zeros(N_BS,T_last);
% for i = 1:N_BS
%     solarR = rand();
%     if solarR < 1/2
%      %solar_BS_1s_1day(i,:) = (0.4*rand(1,T_last)+0.8) .* solar_EBU_1day' *Enecov_eff*Panelsize; %0.15*0.6
%      solar_subR = 4*rand();
%      solar_BS_1s_1day(i,:) = (0.4*rand(1,T_last)+0.8) .* EBU1(72929+14400+T_last*(floor(solar_subR)) : 72929+14400+T_last*(floor(solar_subR))+T_last-1)' *Enecov_eff*Panelsize; %0.15*0.6
%     elseif solarR>=1/2 && solarR < 1
%      %solar_BS_1s_1day(i,:) = (0.4*rand(1,T_last)+0.8) .* solar_Mesa_1day ' *Enecov_eff*Panelsize; %0.15*0.6
%      solar_subR = 4*rand();
%      solar_BS_1s_1day(i,:) = (0.4*rand(1,T_last)+0.8) .* Mesa(72929+14400+T_last*(floor(solar_subR)) : 72929+14400+T_last*(floor(solar_subR))+T_last-1)' *Enecov_eff*Panelsize; %0.15*0.6
%     else
%      %solar_BS_1s_1day(i,:) = (0.4*rand(1,T_last)+0.8) .* solar_Mesa2_1day' *Enecov_eff*Panelsize; %0.15*0.6
%     end
% end
deff_ratio = 0.2*rand(N_BS,1)+0.9;
solarR = 3*rand(N_BS,1);
solar_BS_1s_1day = solar_data_pros(ceil(solarR),:)*Enecov_eff*Panelsize.*deff_ratio;

%% UE generation
s = rng;

run('C:\Users\ejm3bp6\Desktop\Boss\Green_HETNET_VANET_network_with_MEC_and_RE\simulation\0309_one_street_simulation\map_coordination_5BS.m');
solar_BS_1s_1day_guess = solar_BS_1s_1day;
UE_XULrate_guess = UE_XULrate_Record;  
UE_XDLrate_guess = UE_XDLrate_Record;  
Allocate_solar_BS_1day_guess = Allocate_solar_BS_1day;
UE_List_guess = UE_List_record;
N_UE_guess    = N_UE_record;
EnergyCom_BS_prereasso = EnergyCom_BS_min;
Asso_UE_record_prereasso = Asso_UE_record;
UE_ListAssoAB_Record_prereasso = UE_ListAssoAB_Record;
ULRB_needed_min_prereasso = ULRB_needed_min;
DLRB_needed_min_prereasso = DLRB_needed_min;
Com_needed_min_prereasso  = Com_needed_min;
%do with bs min power
disp('reasso with bs min power');
[Asso_UE_guess,EnergyCom_BS_guess,UE_ListAssoAB_guess,ULRB_needed_guess,DLRB_needed_guess,Com_needed_guess] ...
    = Reassociation_wm(1,UE_List_record,N_UE_record,UE_XULrate_Record,UE_XDLrate_Record,...
                       Asso_UE_record,Allocate_solar_BS_1day,EnergyCom_BS_min,UE_ListAssoAB_Record,...
                       ULRB_needed_min,DLRB_needed_min,Com_needed_min);
%run('C:\Users\ejm3bp6\Desktop\Boss\Green_HETNET_VANET_network_with_MEC_and_RE\simulation\0218_whole_simulation\Reassociation_wm.m');

disp('reasso without bs min power');
%do without bs min power
[Asso_UE_guess_womin,EnergyCom_BS_guess_womin,UE_ListAssoAB_guess_womin,ULRB_needed_guess_womin,DLRB_needed_guess_womin,Com_needed_guess_womin] ...
    = Reassociation_wm(0,UE_List_record,N_UE_record,UE_XULrate_Record,UE_XDLrate_Record,...
                       Asso_UE_record_womin,Allocate_solar_BS_1day_womin,EnergyCom_BS_womin,UE_ListAssoAB_Record_womin,...
                       ULRB_needed_womin,DLRB_needed_womin,Com_needed_womin);

%solar_BS_1s_1day = zeros(N_BS,T_last);
%% define true solar:
for i = 1:N_BS
     solar_BS_1s_1day(i,:) = (0.4*rand(1,T_last)+0.8) .* solar_BS_1s_1day(i,:); %0.15*0.6
end


%% set true solar alignment input:(with BS min power)
disp('true solar alignment with bs min power');
%ratio = Allocate_solar_BS_1day_guess./EnergyCom_BS_guess;
[battery_record_wm,Asso_UE_guess_final_wm,Allocate_solar_BS_1day_final_wm,EnergyCom_BS_guess_final_wm,...
 ULRB_needed_guess_final_wm,DLRB_needed_guess_final_wm,Com_needed_guess_final_wm,UE_ListAssoAB_guess_final_wm]...
 = true_solar_alingment(1,EnergyCom_BS_guess,Asso_UE_guess,UE_ListAssoAB_guess,solar_BS_1s_1day,...
                        ULRB_needed_guess,DLRB_needed_guess,Com_needed_guess,UE_XULrate_guess,UE_XDLrate_guess,UE_List_guess);


disp('true solar alignment without bs min power');
%% set true solar alignment input:(without BS min power)
[battery_record_womin,Asso_UE_guess_final_womin,Allocate_solar_BS_1day_final_womin,EnergyCom_BS_guess_final_womin,...
 ULRB_needed_guess_final_womin,DLRB_needed_guess_final_womin,Com_needed_guess_final_womin,UE_ListAssoAB_guess_final_womin]...
 = true_solar_alingment(0,EnergyCom_BS_guess_womin,Asso_UE_guess_womin,UE_ListAssoAB_guess_womin,solar_BS_1s_1day,...
                        ULRB_needed_guess_womin,DLRB_needed_min_prereasso,Com_needed_min_prereasso,UE_XULrate_guess,UE_XDLrate_guess,UE_List_guess);


disp('min BS power w/o reassociation');
%% use true solar alingment to compute result w/o reassociation
[Asso_UE_guess_final_norea,EnergyCom_BS_guess_final_norea,...
    ULRB_needed_guess_final_norea,DLRB_needed_guess_final_norea,Com_needed_guess_final_norea,UE_ListAssoAB_guess_final_norea] ...
    = noreassociation(1,EnergyCom_BS_prereasso,Asso_UE_record_prereasso,UE_ListAssoAB_Record_prereasso,Allocate_solar_BS_1day_guess,...
                      ULRB_needed_min_prereasso,DLRB_needed_guess,Com_needed_guess,UE_XULrate_guess,UE_XDLrate_guess,UE_List_guess);
disp('min BS power w/o reassociation - true solar alignment');
%% set true solar alignment input:(w/o reassociation)
[battery_record_norea,Asso_UE_guess_final_norea,Allocate_solar_BS_1day_final_norea,EnergyCom_BS_guess_final_norea,...
 ULRB_needed_guess_final_norea,DLRB_needed_guess_final_norea,Com_needed_guess_final_norea,UE_ListAssoAB_guess_final_norea]...
 = true_solar_alingment(1,EnergyCom_BS_guess_final_norea,Asso_UE_guess_final_norea,UE_ListAssoAB_guess_final_norea,solar_BS_1s_1day,...
                        ULRB_needed_guess_final_norea,DLRB_needed_guess_final_norea,Com_needed_guess_final_norea,UE_XULrate_guess,UE_XDLrate_guess,UE_List_guess);
                  
                  
                  
%% calculate true solar result
disp('calculate true solar result');
rng(s);
run('C:\Users\ejm3bp6\Desktop\Boss\Green_HETNET_VANET_network_with_MEC_and_RE\simulation\0309_one_street_simulation\map_coordination_5BS.m');
[Asso_UE_true,EnergyCom_BS_true,UE_ListAssoAB_true,ULRB_needed_true,DLRB_needed_true,Com_needed_true] ...
    = Reassociation_wm(1,UE_List_record,N_UE_record,UE_XULrate_Record,UE_XDLrate_Record,...
                       Asso_UE_record,Allocate_solar_BS_1day,EnergyCom_BS_min,UE_ListAssoAB_Record,...
                       ULRB_needed_min,DLRB_needed_min,Com_needed_min);
disp('true-solar: without bs min power');
[Asso_UE_true_womin,EnergyCom_BS_true_womin,UE_ListAssoAB_true_womin,ULRB_needed_true_womin,DLRB_needed_true_womin,Com_needed_true_womin] ...
    = Reassociation_wm(0,UE_List_record,N_UE_record,UE_XULrate_Record,UE_XDLrate_Record,...
                       Asso_UE_record_womin, Allocate_solar_BS_1day_womin , EnergyCom_BS_womin ,UE_ListAssoAB_Record_womin,...
                       ULRB_needed_womin,DLRB_needed_womin,Com_needed_womin);
disp('true-solar: min BS power w/o reassociation');
[Asso_UE_true_norea,EnergyCom_BS_true_norea,...
    ULRB_needed_true_norea,DLRB_needed_true_norea,Com_needed_true_norea,UE_ListAssoAB_true_norea] ...
    = noreassociation(1,EnergyCom_BS_min, Asso_UE_record,UE_ListAssoAB_Record,Allocate_solar_BS_1day,...
                      ULRB_needed_min,DLRB_needed_min,Com_needed_min,UE_XULrate_Record,UE_XDLrate_Record,UE_List_record);
[Asso_UE_true_norea_womin,EnergyCom_BS_true_norea_womin,...
    ULRB_needed_true_norea_womin,DLRB_needed_true_norea_womin,Com_needed_true_norea_womin,UE_ListAssoAB_true_norea_womin] ...
    = noreassociation(0,EnergyCom_BS_womin, Asso_UE_record_womin,UE_ListAssoAB_Record_womin,Allocate_solar_BS_1day_womin,...
                      ULRB_needed_womin,DLRB_needed_womin,Com_needed_womin,UE_XULrate_Record,UE_XDLrate_Record,UE_List_record,N_UE_record,ID_Asso_UE_record);
                  
solar_BS_1s_1day_true = solar_BS_1s_1day;
UE_List_true = UE_List_record;
N_UE_true    = N_UE_record;
UE_XULrate_true = UE_XULrate_Record;  
UE_XDLrate_true = UE_XDLrate_Record;  
Allocate_solar_BS_1day_true = Allocate_solar_BS_1day;

if ~isequal(UE_List_true,UE_List_guess)
   warning('rng(s) is not working'); 
end

% Energy_outage = zeros(N_BS,1);
% for b = 1:N_BS
% for i = 1:T_last
%     Energy_outage(b,1) = Energy_outage(b,1)+EnergyCom_BS_min(b,i)-solar_BS_1s_1day_true(b,i);
% end
% end