tng = rng;
%script
global T_last;
T_last = 86400;
global battery_initial_level;
battery_initial_level = 0;
%% DEBUG
global debug_variable_1
global debug_variable_2
global debug_variable_3
%% power parameters:
global BSP_idle;
BSP_idle = 6;
global MEP_idle;
MEP_idle = 4.8;
global Comp_fullW;
Comp_fullW = 1.45;
global ca;
ca = 4414;
global DL_fullW;
DL_fullW = 1;
global UL_fullW;
UL_fullW = 1;
global DL_avalRB;
DL_avalRB = 720;

global UE_Xmitpower;
UE_Xmitpower = 23;%dbm
global BS_Xmitpower;
BS_Xmitpower = 30;
km = 1000;
BW = 12*(15e3); 
Noise = -174+10*log10(BW) ;
Fc = 1.7;     %Ghz
Con_delay = 0.05; % will be Con_delay+rand()*Con_delay
MULVOLUMN = 1;
global afa;
afa = Comp_fullW /ca;
global P_d_RB;
P_d_RB  = ( 10^(BS_Xmitpower/10)/1000 /10*0.18 ) + (2/DL_avalRB);%Pb + Pc transform to W per RB, Pc: 1W for one Band, 2W for 2 Band
global P_u_RB;
P_u_RB = (2/DL_avalRB);
%% assign solar power
x_limit = 3014.87;
global N_BS;
BS_dist = 400;
N_BS = floor((x_limit-BS_dist/2)/BS_dist)+1;
Location_BS = zeros(N_BS,2);
for bs = 1:N_BS
    Location_BS(bs,:) = [BS_dist/2 + BS_dist*(bs-1) 0.1];
%     scatter(Location_BS(bs,1),Location_BS(bs,2),'ro');
%     hold on
end

% load('Solar_parced_data.mat');
% Panelsize =  ( 0.2+0.2*0.3 ) *Mul;  %bifacial: 1.6+1.6*0.3
% Enecov_eff = 0.18;
load('solar_Mul_2_5.mat');
Mul = 2.5;
temp_solar = solar_BS_1s_1day;
solar_BS_1s_1day = max( temp_solar(1:N_BS,:), 0);
for i = 1:N_BS
    solar_BS_1s_1day(i,:) = solar_BS_1s_1day(i,:)*Mul/2.5;
    if i == 1 
       solar_BS_1s_1day(i,:) = solar_BS_1s_1day(i,:)*0.98;
    elseif i == 3 || i == 7 || i == 9
       solar_BS_1s_1day(i,:) = solar_BS_1s_1day(i,:)*0.96;
    end
end
disp('solar and BS parameter done');


%% UE generation
disp('UE generation');
%rng(s);
run('map_coordination_5BS.m');

% filename = [ 'simulation_result_201804300200\UEData_N_BS_' num2str(N_BS) '.mat'];
% save(filename);

%% QLM
%TEBA:
disp('Alg balancing');
     Allocate_solar_BS_1day = solar_1cell_balancing_maxmin_sust(solar_BS_1s_1day,EnergyCom_BS_min);
     Battery_record_alg = battery_transform(solar_BS_1s_1day,Allocate_solar_BS_1day);  
%SEBA:
disp('SEBA');
[Asso_UE_true_alg,EnergyCom_BS_true_alg,Com_needed_true_alg,UE_comneed_true_alg] ...
    = Reassociation_wm_ho(1,1,UE_List_record,N_UE_record,ID_Asso_UE_record,UE_XULrate_Record,UE_XDLrate_Record,...
                       Asso_UE_record,Allocate_solar_BS_1day,EnergyCom_BS_min,...
                       Com_needed_min,UE_comneed_min);
EnergyCom_BS_true_alg_final = min(Allocate_solar_BS_1day,EnergyCom_BS_true_alg);
Battery_record_alg = battery_transform(solar_BS_1s_1day,EnergyCom_BS_true_alg_final);  
     %calculate QoS loss
     target_asso_alg = Asso_UE_true_alg;
     unasso_alg = zeros(1,T_last/t_granu);
     hover_alg = zeros(1,T_last/t_granu);
     for  ts = 2:T_last/t_granu
        for u = 1:N_UE_record(1,ts)
            preassoflag = ID_Asso_UE_record(u,1,ts) == ID_Asso_UE_record(:,1,ts-1);
            idx_u = find(preassoflag);
            if target_asso_alg(u, ts) == 0
               unasso_alg(1,ts) = unasso_alg(1,ts) + 1; 
            elseif ~isempty(idx_u)
               if target_asso_alg(u, 1, ts) ~= target_asso_alg(idx_u, 1, ts-1) && target_asso_alg(idx_u, 1, ts-1)~= 0
                  hover_alg(1,ts)  = hover_alg(1,ts)  + 1;
               end
            end
        end     
     end
     cost_alg = unasso_alg + 0.1*hover_alg;
     perm = num2str(sum(cost_alg,2)/sum(N_UE_record,2));

% iteration:
disp('start iteration');

num_ite = 10;
Allocate_solar_BS_1day_ite = zeros(num_ite,N_BS,T_last);
Allocate_solar_BS_1day_ite(1,:,:) = reshape( Allocate_solar_BS_1day, [1, size(Allocate_solar_BS_1day)] );
EnergyCom_BS_min_ite       = zeros(num_ite,N_BS,T_last);
EnergyCom_BS_min_ite(1,:,:) = reshape( EnergyCom_BS_true_alg, [1, size(EnergyCom_BS_min)] );
Asso_UE_record_ite          = zeros( [ num_ite, size(Asso_UE_record)] );
Asso_UE_record_ite(1,:,:)   = reshape( Asso_UE_true_alg, [1, size(Asso_UE_record)] );
Battery_alg_ite            = zeros( [ num_ite, size(Battery_record_alg)] );
Battery_alg_ite(1,:,:)   = reshape( Battery_record_alg, [1, size(Battery_record_alg)] );
adv1 = true;
ite = 1;
while adv > 0.1 && adv1 && ite<num_ite
    ite = ite + 1;
    perm_temp = perm;
    temp_EnergyCom_BS_min = reshape( EnergyCom_BS_min_ite(ite-1,:,:), size(EnergyCom_BS_min) );
     disp(['iteration :' num2str(ite-1)]); 
    temp_Allocate_solar_BS_1day = solar_1cell_balancing_maxmin_sust(solar_BS_1s_1day,temp_EnergyCom_BS_min);
    temp_Battery  = battery_transform(solar_BS_1s_1day,temp_Allocate_solar_BS_1day); 
    temp_Asso_UE_record = reshape( Asso_UE_record_ite(ite-1,:,:), size(Asso_UE_record) );
    
    disp(['iteration :' num2str(ite-1)]);
    [temp_Asso_UE_alg,temp_EnergyCom_BS_alg,temp_Com_needed_min,temp_UE_comneed_alg] ...
    = Reassociation_wm_ho(1,1,UE_List_record,N_UE_record,ID_Asso_UE_record,UE_XULrate_Record,UE_XDLrate_Record,...
                       Asso_UE_record,temp_Allocate_solar_BS_1day,EnergyCom_BS_min,...
                       Com_needed_min,UE_comneed_min);                    
                   
     Allocate_solar_BS_1day_ite(ite,:,:) = reshape( temp_Allocate_solar_BS_1day, [1, size(Allocate_solar_BS_1day)] );
     EnergyCom_BS_min_ite(ite,:,:) = reshape( temp_EnergyCom_BS_alg, [1, size(EnergyCom_BS_min)] );
     Asso_UE_record_ite(ite,:,:)   = reshape( temp_Asso_UE_alg, [1, size(Asso_UE_true_alg)] );
     Battery_alg_ite(ite,:,:)      = reshape( temp_Battery, [1, size(Battery_record_alg)] );

     %calculate QoS loss
     target_asso_alg = temp_Asso_UE_alg;
     unasso_alg = zeros(1,T_last/t_granu);
     hover_alg = zeros(1,T_last/t_granu);
     for  ts = 2:T_last/t_granu
        for u = 1:N_UE_record(1,ts)
            preassoflag = ID_Asso_UE_record(u,1,ts) == ID_Asso_UE_record(:,1,ts-1);
            idx_u = find(preassoflag);
            if target_asso_alg(u, ts) == 0
               unasso_alg(1,ts) = unasso_alg(1,ts) + 1; 
            elseif ~isempty(idx_u)
               if target_asso_alg(u, 1, ts) ~= target_asso_alg(idx_u, 1, ts-1) && target_asso_alg(idx_u, 1, ts-1)~= 0
                  hover_alg(1,ts)  = hover_alg(1,ts)  + 1;
               end
            end
        end     
     end

     cost_alg = unasso_alg + 0.1*hover_alg;
     perm = num2str(sum(cost_alg,2)/sum(N_UE_record,2));
     adv = (perm_temp-perm)/perm_temp;
     adv1 = perm<perm_temp;
end
%% OGEC
disp('greedy balancing OGEC'); %will be no-reassociation
    [ Allocate_solar_BS_1day_greedy, flagG] = solar_1cell_balancing_greedy(solar_BS_1s_1day,EnergyCom_BS_min);
    %Battery_record_greedy = battery_transform(solar_BS_1s_1day,Allocate_solar_BS_1day_greedy);
    if flagG == 0
        warning('greedy invalid');
        pause;
    end
disp('OGEC geedy balancing');
[Asso_UE_true_gdy,EnergyCom_BS_true_gdy,Com_needed_true_gdy,UE_comneed_true_gdy] ...
    = Reassociation_wm_ho(1,1,UE_List_record,N_UE_record,ID_Asso_UE_record,UE_XULrate_Record,UE_XDLrate_Record,...
                       Asso_UE_record,Allocate_solar_BS_1day_greedy,EnergyCom_BS_min,...
                       Com_needed_min,UE_comneed_min);      
EnergyCom_BS_true_gdy_final = min(Allocate_solar_BS_1day_greedy,EnergyCom_BS_true_gdy);
Battery_record_greedy = battery_transform(solar_BS_1s_1day,EnergyCom_BS_true_gdy_final);    
%% RGEC:
disp('greedy balancing RGEC');
    [ Allocate_solar_BS_1day_greedy_2, flagG2] = solar_1cell_balancing_greedy_2(solar_BS_1s_1day,EnergyCom_BS_min);
    %Battery_record_greedy_2 = battery_transform(solar_BS_1s_1day,Allocate_solar_BS_1day_greedy_2);
    if flagG2 == 0
        warning('greedy 2 invalid');
        pause;
    end
disp('RGEC geedy balancing');
[Asso_UE_true_gdy_2,EnergyCom_BS_true_gdy_2,Com_needed_true_gdy_2,UE_comneed_true_gdy_2] ...
    = Reassociation_wm_ho(1,1,UE_List_record,N_UE_record,ID_Asso_UE_record,UE_XULrate_Record,UE_XDLrate_Record,...
                       Asso_UE_record,Allocate_solar_BS_1day_greedy_2,EnergyCom_BS_min,...
                       Com_needed_min,UE_comneed_min);      
EnergyCom_BS_true_gdy_2_final = min(Allocate_solar_BS_1day_greedy_2,EnergyCom_BS_true_gdy_2);
Battery_record_greedy_2 = battery_transform(solar_BS_1s_1day,EnergyCom_BS_true_gdy_2_final);