function [battery_record,Asso_UE_guess_final,Allocate_solar_BS_1day_final,EnergyCom_BS_guess_final,ULRB_needed_guess_final,DLRB_needed_guess_final,Com_needed_guess_final,UE_ListAssoAB_guess_final] = true_solar_alingment(minpower,EnergyCom_BS_guess,Asso_UE_guess,UE_ListAssoAB_guess,solar_BS_1s_1day,ULRB_needed_guess,DLRB_needed_guess,Com_needed_guess,UE_XULrate_guess,UE_XDLrate_guess,UE_List_guess)

global battery_initial_level;
global T_last;
global N_BS;

%true solar alingment
%we have:
% Asso_UE_guess
% ULRB_needed_guess = ULRB_needed_min;
% DLRB_needed_guess = DLRB_needed_min;
% Com_needed_guess = Com_needed_min;
% solar_BS_1s_1day_true = solar_BS_1s_1day;
% 1.  create new Allocate_solar_BS_1day_true based on actual solar_BS_1s_1day, allocated power ratio and a battery
% ( try to reach the adjusted ratio, if more, store to battery, if less, drain from battery.
% 2. create new EnergyCom_BS_true, with initial value EnergyCom_BS_guess
% 3. for each BS, if EnergyCom_BS_true > Allocate_solar_BS_1day_true and battery has remaining power, 
% add the battery to  Allocate_solar_BS_1day_true until power = 1; if
% battery  = 0; start throw ue away.
battery_record               = zeros(N_BS,T_last);
battery_record(:,1)          = battery_initial_level;
EnergyCom_BS_guess_final     = EnergyCom_BS_guess;
Allocate_solar_BS_1day_final = zeros(N_BS,T_last);
ULRB_needed_guess_final      = zeros(N_BS,T_last);
DLRB_needed_guess_final      = zeros(N_BS,T_last);
Com_needed_guess_final       = zeros(N_BS,T_last);
UE_ListAssoAB_guess_final    = zeros( size(UE_ListAssoAB_guess)); 
Asso_UE_guess_final          = Asso_UE_guess;

for ts = 1:T_last
    if mod(ts,5000) == 0
       disp(['true solar adjustment: ' num2str(ts)] );
    end          
   for bs = 1:N_BS
       if solar_BS_1s_1day( bs , ts) >= EnergyCom_BS_guess_final( bs , ts )
   
          Allocate_solar_BS_1day_final( bs , ts ) = EnergyCom_BS_guess_final( bs , ts );
          EnergyCom_BS_guess_final( bs , ts ) = EnergyCom_BS_guess( bs , ts );
          ULRB_needed_guess_final( bs , ts ) = ULRB_needed_guess( bs , ts );
          DLRB_needed_guess_final( bs , ts ) = DLRB_needed_guess( bs , ts );
          Com_needed_guess_final( bs , ts ) = Com_needed_guess( bs , ts );
          
          bflag = Asso_UE_guess_final(:,1,ts) == bs;
          UE_ListAssoAB_guess_final(bflag,:,ts) = UE_ListAssoAB_guess(bflag,:,ts);
          battery_record(bs,ts) = battery_record(bs,max(ts-1,1)) + solar_BS_1s_1day( bs , ts)-EnergyCom_BS_guess_final( bs , ts );
       else
          if ts > 1 
              if battery_record(bs,ts-1)>= EnergyCom_BS_guess_final( bs , ts ) - solar_BS_1s_1day( bs , ts)
               
                 Allocate_solar_BS_1day_final( bs , ts ) = EnergyCom_BS_guess_final( bs , ts );
                 EnergyCom_BS_guess_final( bs , ts ) = EnergyCom_BS_guess( bs , ts );
                 ULRB_needed_guess_final( bs , ts ) = ULRB_needed_guess( bs , ts );
                 DLRB_needed_guess_final( bs , ts ) = DLRB_needed_guess( bs , ts );
                 Com_needed_guess_final( bs , ts ) = Com_needed_guess( bs , ts );
          
                 bflag = Asso_UE_guess_final(:,1,ts) == bs;
                 UE_ListAssoAB_guess_final(bflag,:,ts) = UE_ListAssoAB_guess(bflag,:,ts);
                 battery_record(bs,ts) = battery_record(bs,ts-1) + solar_BS_1s_1day( bs , ts) - EnergyCom_BS_guess_final( bs , ts );
                 if battery_record(bs,ts) < 0
                    warning('battery level < 0');
                    pause;
                 end
              else
                ULRB_needed_guess_final( bs , ts ) = ULRB_needed_guess( bs , ts );
                UE_ListAssoAB_guess_final(bflag,:,ts) = UE_ListAssoAB_guess(bflag,:,ts);
                bflag = Asso_UE_guess_final(:,1,ts) == bs;
                %Idx_ue = find(bflag);
                TN_UE = sum(bflag,1);   
                while (  battery_record(bs,ts-1) < EnergyCom_BS_guess_final( bs , ts ) - solar_BS_1s_1day( bs , ts) && TN_UE > 0)
                  %disp([ 'TN_UE = ' num2str(TN_UE) ': enter while loop with battery_record(' num2str(bs) ' , ' num2str(ts-1) ' ) = '  num2str(battery_record(bs,ts-1)) ' < ' num2str(EnergyCom_BS_guess_final( bs , ts )) ' - ' num2str(solar_BS_1s_1day( bs , ts))]);
                  %start to drop
                  bflag = Asso_UE_guess_final(:,1,ts) == bs;
                  Idx_ue = find(bflag);
                  Energ_cont = BSpowerf( ceil(UE_List_guess(bflag,5,ts)./UE_XULrate_guess(bflag,bs,ts)) , ...
                                         reshape(UE_ListAssoAB_guess_final(bflag,3,ts),size(UE_List_guess(bflag,5,ts))) ,...
                                         reshape(UE_ListAssoAB_guess_final(bflag,2,ts),size(UE_List_guess(bflag,5,ts))));
                  if isequal(size(Energ_cont),size(bflag))
                     warning('size of Energ_cont is not right'); 
                  end
                  [max_econ, Idx_ue_econ] =  max(Energ_cont,[],1); 
                  
                  %delete Idx_ue_econ(inside loop) or  Idx_ue(Idx_ue_econ,1)(outside loop)
                  temp_ULRB_needed = ULRB_needed_guess_final( bs , ts ) - ceil( UE_List_guess( Idx_ue(Idx_ue_econ,1) , 5 , ts )/UE_XULrate_guess(Idx_ue(Idx_ue_econ,1) , bs ,ts) ) ;
                  Asso_UE_guess_final ( Idx_ue(Idx_ue_econ,1) , : , ts ) = reshape( 0  , size(Asso_UE_guess_final(1,:,1)) );
                  bflag( Idx_ue(Idx_ue_econ,1),1) = 0;
                  %disp('running minpower1BS_w_limComRB_func');
                  if minpower
                  [UE_ListAssoAB_temp_o, Resouce_needed_temp_o, Valid_temp_o] = minpower1BS_w_limComRB_func( UE_List_guess(bflag,:,ts)  ,  UE_XDLrate_guess(bflag,:,ts), bs );
                  else
                  [UE_ListAssoAB_temp_o, Resouce_needed_temp_o, Valid_temp_o] = minpower1BS_wo_limComRB_func( UE_List_guess(bflag,:,ts)  ,  UE_XDLrate_guess(bflag,:,ts), bs );
                  end
                  %disp('finished running minpower1BS_w_limComRB_func');
                     if Valid_temp_o == 0
                         warning('delete a ue and a_b_i become invalid'); 
                      end
                  UE_ListAssoAB_guess_final( bflag , : , ts )                =  reshape( UE_ListAssoAB_temp_o , [ size(UE_ListAssoAB_temp_o) , 1 ] );
                  UE_ListAssoAB_guess_final( Idx_ue(Idx_ue_econ,1) , : , ts) =  zeros( size(UE_ListAssoAB_guess_final( Idx_ue(Idx_ue_econ,1) , : , 1)) );
                      
                  DLRB_needed_guess_final( bs , ts ) =  Resouce_needed_temp_o(1,2);
                  ULRB_needed_guess_final( bs , ts ) =  temp_ULRB_needed;
                  Com_needed_guess_final( bs , ts )  =  Resouce_needed_temp_o(1,1);        
                  EnergyCom_BS_guess_final( bs , ts ) =  BSpowerf(ULRB_needed_guess_final(bs,ts),DLRB_needed_guess_final(bs,ts),Com_needed_guess_final(bs,ts));
                  Allocate_solar_BS_1day_final( bs , ts ) = EnergyCom_BS_guess_final( bs , ts );
                  TN_UE = sum(bflag,1); 
                end
                 if battery_record(bs,ts-1) > EnergyCom_BS_guess_final( bs , ts ) - solar_BS_1s_1day( bs , ts)
                    battery_record(bs,ts) = battery_record(bs,ts-1) + solar_BS_1s_1day( bs , ts) - EnergyCom_BS_guess_final( bs , ts );
                 else
                    battery_record(bs,ts) = battery_record(bs,ts-1)+solar_BS_1s_1day( bs , ts);
                    EnergyCom_BS_guess_final( bs , ts ) = 1e-3; %means that the BS is shut down
                    Allocate_solar_BS_1day_final( bs , ts )= 0;
                    if TN_UE > 0 
                       warning('EnergyCom_BS_guess_final( bs , ts ) is not pushed to the minimum');
                    end
                 end
               end
          else %ts = 1(battery = 0) and solar_BS_1s_1day( bs , ts) < Allocate_solar_BS_1day_guess( bs , ts )
              if battery_record(bs,ts) >= EnergyCom_BS_guess_final( bs , ts ) - solar_BS_1s_1day( bs , ts)
               
                 Allocate_solar_BS_1day_final( bs , ts ) = EnergyCom_BS_guess_final( bs , ts );
                 EnergyCom_BS_guess_final( bs , ts ) = EnergyCom_BS_guess( bs , ts );
                 ULRB_needed_guess_final( bs , ts ) = ULRB_needed_guess( bs , ts );
                 DLRB_needed_guess_final( bs , ts ) = DLRB_needed_guess( bs , ts );
                 Com_needed_guess_final( bs , ts ) = Com_needed_guess( bs , ts );
          
                 bflag = Asso_UE_guess_final(:,1,ts) == bs;
                 UE_ListAssoAB_guess_final(bflag,:,ts) = UE_ListAssoAB_guess(bflag,:,ts);
                 battery_record(bs,ts) = battery_record(bs,ts) + solar_BS_1s_1day( bs , ts) - EnergyCom_BS_guess_final( bs , ts );
                 if battery_record(bs,ts) < 0
                    warning('battery level < 0');
                    pause;
                 end
              else
                ULRB_needed_guess_final( bs , ts ) = ULRB_needed_guess( bs , ts );
                UE_ListAssoAB_guess_final(bflag,:,ts) = UE_ListAssoAB_guess(bflag,:,ts);
                bflag = Asso_UE_guess_final(:,1,ts) == bs;
                Idx_ue = find(bflag);
                TN_UE = sum(bflag,1);   
                while (  0 < EnergyCom_BS_guess_final( bs , ts ) - solar_BS_1s_1day( bs , ts) && TN_UE > 0)
                  %start to drop
                  %[ 'TN_UE = ' num2str(TN_UE) ': enter while loop with battery_record(' num2str(bs) ' , ' num2str(ts-1) ' ) = '  num2str(battery_record(bs,ts-1)) ' < ' num2str(EnergyCom_BS_guess_final( bs , ts )) ' - ' num2str(solar_BS_1s_1day( bs , ts))]
                  bflag = Asso_UE_guess_final(:,1,ts) == bs;
                  Idx_ue = find(bflag);
                  Energ_cont = BSpowerf( ceil(UE_List_guess(bflag,5,ts)./UE_XULrate_guess(bflag,bs,ts)) , ...
                                         reshape(UE_ListAssoAB_guess_final(bflag,3,ts),size(UE_List_guess(bflag,5,ts))) ,...
                                         reshape(UE_ListAssoAB_guess_final(bflag,2,ts),size(UE_List_guess(bflag,5,ts))));
                  if isequal(size(Energ_cont),size(bflag))
                     warning('size of Energ_cont is not right'); 
                  end
                  [max_econ, Idx_ue_econ] =  max(Energ_cont,[],1); 
                  
                  %delete Idx_ue_econ(inside loop) or  Idx_ue(Idx_ue_econ,1)(outside loop)
                  temp_ULRB_needed = ULRB_needed_guess_final( bs , ts ) - ceil( UE_List_guess( Idx_ue(Idx_ue_econ,1) , 5 , ts )/UE_XULrate_guess(Idx_ue(Idx_ue_econ,1) , bs ,ts) ) ;
                  Asso_UE_guess_final ( Idx_ue(Idx_ue_econ,1) , : , ts ) = reshape( 0  , size(Asso_UE_guess_final(1,:,1)) );
                  bflag( Idx_ue(Idx_ue_econ,1),1) = 0;
                  if minpower
                  [UE_ListAssoAB_temp_o, Resouce_needed_temp_o, Valid_temp_o] = minpower1BS_w_limComRB_func( UE_List_guess(bflag,:,ts)  ,  UE_XDLrate_guess(bflag,:,ts), bs );
                  else
                  [UE_ListAssoAB_temp_o, Resouce_needed_temp_o, Valid_temp_o] = minpower1BS_wo_limComRB_func( UE_List_guess(bflag,:,ts)  ,  UE_XDLrate_guess(bflag,:,ts), bs );
                  end
                     if Valid_temp_o == 0
                         warning('delete a ue and a_b_i become invalid'); 
                      end
                  UE_ListAssoAB_guess_final( bflag , : , ts )                =  reshape( UE_ListAssoAB_temp_o , [ size(UE_ListAssoAB_temp_o) , 1 ] );
                  UE_ListAssoAB_guess_final( Idx_ue(Idx_ue_econ,1) , : , ts) =  zeros( size(UE_ListAssoAB_guess_final( Idx_ue(Idx_ue_econ,1) , : , 1)) );
                      
                  DLRB_needed_guess_final( bs , ts ) =  Resouce_needed_temp_o(1,2);
                  ULRB_needed_guess_final( bs , ts ) =  temp_ULRB_needed;
                  Com_needed_guess_final( bs , ts )  =  Resouce_needed_temp_o(1,1);        
                  EnergyCom_BS_guess_final( bs , ts ) =  BSpowerf(ULRB_needed_guess_final(bs,ts),DLRB_needed_guess_final(bs,ts),Com_needed_guess_final(bs,ts));
                  Allocate_solar_BS_1day_final( bs , ts ) = EnergyCom_BS_guess_final( bs , ts );
                  TN_UE = sum(bflag,1); 
                end
                 if 0 > EnergyCom_BS_guess_final( bs , ts ) - solar_BS_1s_1day( bs , ts)
                    battery_record(bs,ts) = 0 + solar_BS_1s_1day( bs , ts) - EnergyCom_BS_guess_final( bs , ts );
                 else
                    battery_record(bs,ts)  =   solar_BS_1s_1day( bs , ts);
                    battery_record(bs,ts) = 0;
                    EnergyCom_BS_guess_final( bs , ts ) = 1e-3; %means that the BS is shut down
                    Allocate_solar_BS_1day_final( bs , ts ) = 0;
                    if TN_UE > 0 
                       warning('EnergyCom_BS_guess_final( bs , ts ) is not pushed to the minimum');
                    end
                 end
               end              
          end
       end
       
   end
end
end